package  
{
	import flash.display.BitmapData;
	import flash.events.Event;
	import flash.geom.Point;
	import flash.utils.ByteArray;
	import net.flashpunk.Entity;
	import net.flashpunk.FP;
	import net.flashpunk.utils.Draw;
	
	import flash.net.URLRequestMethod;
	import flash.net.URLVariables;
	import flash.net.URLLoader;
	import flash.net.URLLoaderDataFormat;
	import flash.net.URLRequest;
	
	public class Canvas extends Entity 
	{
		public static var canvas:Canvas = new Canvas();
		
		public var area:Point = new Point();
		public var buffer:BitmapData;
		public var wipePos:Number = -0.1;
		public var downloaded:Boolean = false;
		
		public function Canvas(w:int = 32, h:int = 32) 
		{
			area = new Point(w, h);
			buffer = new BitmapData(w, h, false, 0xFFFFFF);
		}
		
		public function wipe() : void
		{
			if(valid() && DoodleWorld.guessMode == false)
				upload();
				
			wipePos = 1.0;
		}
		
		public function valid() : Boolean
		{
			var minValid = 100;
			var numValid:int = 0;
			for (var xpos:int = 0; xpos < buffer.width; xpos++)
			{
				for (var ypos:int = 0; ypos < buffer.height; ypos++)
				{
					var col:uint = buffer.getPixel(xpos, ypos);
					if (col != 0xFFFFFF)
					{
						numValid += 1;
						if (numValid > minValid)
							return true;
					}
				}
			}
			return false;
		}
		
		public function upload() : void 
		{
			var data:ByteArray = PNGEncoder.encode(buffer);
			var stringData:String = "";
			data.position = 0;
			
			for (var j : int = 0; j < data.length; j++) 
			{
				var n:String=data.readUnsignedByte().toString(16); 
				if (n.length < 2)
				{ 
					n="0"+n; 
				} 
				stringData+=n; 
			} 
			
			var variables:URLVariables = new URLVariables("sendRequest=crappyDoodles");
			variables.id = DoodleWorld.UserID;
			variables.data = stringData;
			variables.word = DoodleWorld.currentWord;
			var varSend:URLRequest = new URLRequest("http://www.wonthelp.info/crappydoodle/sendImage.php");
			varSend.method = URLRequestMethod.POST;
			varSend.data = variables;
			var varLoader:URLLoader = new URLLoader;
			varLoader.dataFormat = URLLoaderDataFormat.VARIABLES;
			varLoader.addEventListener(Event.COMPLETE, onUpload);
			varLoader.load(varSend);
		}
		
		private function onUpload(e:Event) : void
		{
			
		}
		
		public function download() : void 
		{
			downloaded = false;
			
			var variables:URLVariables = new URLVariables("sendRequest=crappyDoodles");
			variables.id = DoodleWorld.UserID;
			variables.guesses = User.guesses;
			if (User.guesses == "")
				variables.guesses = "-1";
			
			var varSend:URLRequest = new URLRequest("http://www.wonthelp.info/crappydoodle/getRandomImage.php");
			varSend.method = URLRequestMethod.POST;
			varSend.data = variables;
			// Build the varLoader variable
			var varLoader:URLLoader = new URLLoader;
			varLoader.dataFormat = URLLoaderDataFormat.VARIABLES;
			varLoader.addEventListener(Event.COMPLETE, onDownload);
			varLoader.load(varSend);
			
			Loader.loading = true;
		}
		
		private function onDownload(e:Event) : void
		{
			downloaded = true;
			if ( e.target.data != null && e.target.data != "")
			{
				var id:int = int(e.target.data.id);
				var user:String = e.target.data.user as String;
				var data:String = e.target.data.data as String;
				var word:String = e.target.data.word as String;
				
				var bA =new ByteArray (); 
				var data1:Array=data.split(""); 
				var data2:Array=[]; 
				for (var i : int = 0; i < data1.length; i += 2) 
				{	
					data2.push("0x"+data1 [i]+data1[i+1]); 
				} 
				for (var j : int = 0; j < data2.length; j ++)
				{ 
					bA[j] = data2[j]; 
				}
				
				var png:PNGDecoder = new PNGDecoder();
				buffer = png.decode(bA);
				
				DoodleWorld.currentWord = word;
				LetterDisplay.currentID = id;
				LetterDisplay.currentUser = user;
				Loader.loading = false;
			}
			else
			{
				User.guesses = "";
				download();
			}
		}
		
		public override function render() : void 
		{
			Draw.rectPlus(x - 3, y - 3, area.x + 6, area.y + 6, FP.getColorRGB(200, 200, 200));
			
			if (wipePos > -0.1)
			{
				Draw.setTarget(buffer);
				Draw.rect(((1.0 - wipePos) * buffer.width) - 16, 0, 16, buffer.height);
				Draw.setTarget(FP.buffer);
				
				wipePos -= 0.06;
				
				if (wipePos < -0.1)
					wipePos = -0.1;
			}
			
			FP.buffer.copyPixels(buffer, buffer.rect, new Point(x, y));	
		}
		
	}

}