package  
{
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.geom.Point;
	import net.flashpunk.graphics.Image;
	import net.flashpunk.graphics.Text;
	import net.flashpunk.World;
	import net.flashpunk.FP;
	import net.flashpunk.utils.Input;
	import net.flashpunk.utils.Draw;

	import flash.events.Event;
	import flash.net.URLRequestMethod;
	import flash.net.URLVariables;
	import flash.net.URLLoader;
	import flash.net.URLLoaderDataFormat;
	import flash.net.URLRequest;
	
	import flash.utils.ByteArray;
	
	import flash.net.SharedObject;
	
	public class DoodleWorld extends World 
	{
		public static var UserID:String = "";
		var pen:Pen;
		var image:BitmapData = new BitmapData(640, 480, false, 0xFFFFFFFF);
		var timer:PieTimer;
		var loader:Loader;
		var loadingText:LoadingText;
		private static var display:LetterDisplay;
		public static function get guessMode() : Boolean { return display.guessMode; }
		public static function get currentWord() : String { return display.word; }
		public static function set currentWord(val:String ) { display.word = val; }
		
		[Embed(source = 'assets/MYRIADAS.TTF', embedAsCFF = "false", fontFamily = 'myriad')] private const font:Class;
		public var text:Text = new Text( "", 0, 0 );
		public var text2:Text = new Text( "", 0, 0 );
		
		var startup:Boolean = true;
		var finishStartup:Boolean = false;
		var startupAlpha:Number = 1.0;
		
		
		public static var drawTransition:Boolean = false;
		var drawWait:Number = 0.0;
		public static var guessTransition:Boolean = false;
		var guessWait:Number = 0.0;
		
		public static var showTransition:Boolean = false;
		var showWait:Number = 0.0;
		
		
		var loadWait01:Number = 0.0;
		var loadWait02:Number = 0.0;
		
		
		public function DoodleWorld()
		{
			var sharedOBJ:SharedObject;
			sharedOBJ = SharedObject.getLocal("crappydoodle_guid");
			var id:String = sharedOBJ.data.id as String;
			if (id == null)
				id = GUID.create();
			sharedOBJ.data.id = id;
			sharedOBJ.flush();
			UserID = id;
			
			Input.mouseCursor = "hide";
			User.download();
		}
		
		public override function begin() : void 
		{
			Loader.loading = true;
			
			Canvas.canvas = new Canvas(256, 256);
			add(Canvas.canvas);
			Canvas.canvas.x = (FP.width / 2) - (Canvas.canvas.area.x / 2);
			Canvas.canvas.y = (FP.height / 2) - (Canvas.canvas.area.y / 2);
			
			pen = new Pen();
			add(pen);
			
			timer = new PieTimer(FP.width / 2, 60);
			add(timer);
			
			display = new LetterDisplay();
			display.x = (FP.width / 2) - (display.buffer.width / 2);
			display.y = 390;
			add(display);
			
			loader = new Loader();
			add(loader);
			
			loadingText = new LoadingText();
			add(loadingText);
			loadingText.setText("Looking for user information");
		}
		
		public override function update() : void 
		{
			super.update();
			
			if (drawTransition == false && guessTransition == false && showTransition == false)
			{
				if (startup == false)
				{
					if (timer.time >= 1.0)
					{
						timer.time = 0.0;
						
						if(display.guessMode == false)
							Canvas.canvas.wipe();
							
						display.finishWord();
						if (display.numDrawn == 4)
						{
							if (gotImage != null)
							{
								showTransition = true;
							}
							else if (display.guessMode == false)
							{
								getGuesses();
								guessTransition = true;
							}
							else
							{
								getGuesses();
								drawTransition = true;
							}
							display.inputLock = true;
							Loader.loading = false;
						}
						else
						{
							display.word = "";
							display.typedWord = "";
							display.nextWord();	
						}
						
						User.upload();
					}
				}
				else
				{
					if (User.downloaded && finishStartup == false)
					{
						drawTransition = true;
						display.guessMode = false;
						display.nextWord();
						Loader.loading = false;
						startup = false;
					}
				}
			}
			else
			{
				if (drawTransition)
				{
					timer.time = 0.0;
					drawWait += 0.007;
					if (drawWait > 1.0)
					{
						display.inputLock = false;
						drawTransition = false;
						drawWait = 0.0;
					}
				}
				if (guessTransition)
				{
					timer.time = 0.0;
					guessWait += 0.007;
					if (guessWait > 1.0)
					{
						display.inputLock = false;
						guessTransition = false;
						guessWait = 0.0;
					}
				}
				if (showTransition)
				{
					timer.time = 0.0;
					showWait += 0.004;
					if (showWait > 1.0)
					{
						gotImage = null;
						graph = null;
						gotName = "";
						
						getGuesses();
						if (display.guessMode)
							drawTransition = true;
						else
							guessTransition = true;
						
						gettingImage = false;
						display.inputLock = false;
						showTransition = false;
						showWait = 0.0;
					}
				}
			}
		}
		
		public static function getGuesses() : void 
		{
			var variables:URLVariables = new URLVariables("sendRequest=crappyDoodles");
			variables.id = DoodleWorld.UserID;
			
			var varSend:URLRequest = new URLRequest("http://www.wonthelp.info/crappydoodle/getGuesses.php");
			varSend.method = URLRequestMethod.POST;
			varSend.data = variables;
			// Build the varLoader variable
			var varLoader:URLLoader = new URLLoader;
			varLoader.dataFormat = URLLoaderDataFormat.VARIABLES;
			varLoader.addEventListener(Event.COMPLETE, onGetGuesses);
			varLoader.load(varSend);
		}
		
		private static var gettingImage:Boolean = false;
		private static var gotImage:BitmapData = null;
		private static var gotName:String = "";
		private static var graph:Image = null;
		private static function onGetGuesses(e:Event):void 
		{
			if ( e.target.data != null && e.target.data != "")
			{
				var c:String = e.target.data.correct as String;
				var correct:Array = c.split(",");
				
				if (gettingImage == false && correct.length > 1)
				{
					var image:int = int(correct[1 + Math.round(FP.random * (correct.length - 2))]);
					downloadImage(image);
				}
				
				User.score += correct.length - 1;
				
				/*guesses = e.target.data.guesses as String;
				score = e.target.data.score as int;
				
				var drawnString:String = e.target.data.drawn;
				drawn = drawnString.split(",");*/
			}
		}
		
		public static function downloadImage(id:int) : void 
		{
			gettingImage = true;
			
			var variables:URLVariables = new URLVariables("sendRequest=crappyDoodles");
			variables.id = id;
			
			var varSend:URLRequest = new URLRequest("http://www.wonthelp.info/crappydoodle/getImage.php");
			varSend.method = URLRequestMethod.POST;
			varSend.data = variables;
			// Build the varLoader variable
			var varLoader:URLLoader = new URLLoader;
			varLoader.dataFormat = URLLoaderDataFormat.VARIABLES;
			varLoader.addEventListener(Event.COMPLETE, onDownloadImage);
			varLoader.load(varSend);
		}
		
		private static function onDownloadImage(e:Event) : void
		{
			if ( e.target.data != null && e.target.data != "")
			{
				var id:int = int(e.target.data.id);
				var user:String = e.target.data.user as String;
				var data:String = e.target.data.data as String;
				var word:String = e.target.data.word as String;
				
				var bA =new ByteArray (); 
				var data1:Array=data.split(""); 
				var data2:Array=[]; 
				for (var i : int = 0; i < data1.length; i += 2) 
				{	
					data2.push("0x"+data1 [i]+data1[i+1]); 
				} 
				for (var j : int = 0; j < data2.length; j ++)
				{ 
					bA[j] = data2[j]; 
				}
				
				var png:PNGDecoder = new PNGDecoder();
				gotImage = png.decode(bA);
				gotName = word;
				graph = new Image(gotImage);
			}
		}
		
		
		public override function render() : void 
		{
			/*if (pen.draw)
			{
				Draw.setTarget(image);
				
				//Draw.circlePlus(pen.x, pen.y, 2, 0x000000, 1, true);
				Draw.linePlus(pen.x, pen.y, pen.prevX, pen.prevY, 0x000000, 1, 3);
				//Draw.circlePlus(pen.prevX, pen.prevY, 2, 0x000000, 1, true);
				
				Draw.setTarget(FP.buffer);
			}*/
			
			startupAlpha = Fun.lerp(startupAlpha, (startup || (drawTransition && drawWait < 0.8) || (guessTransition && guessWait < 0.8)|| (showTransition && showWait < 0.8)) ? 1.0 : 0.0, 0.05, 0.05);
			
			if (drawTransition == true)
			{
				loadingText.size = 24;
				loadingText.offset = 0;
				loadingText.setText("Draw 5 Things");
				if (drawWait > 0.8)
				{
					if (display.guessMode == true)
					{
						Canvas.canvas.wipe();
						display.guessMode = false;
						display.numDrawn = -1;
						display.nextWord();	
					}
					loadingText.setText("hide");
				}
			}
			if (guessTransition == true)
			{
				loadingText.size = 24;
				loadingText.offset = 0;
				loadingText.setText("Identify 5 Things");
				if (guessWait > 0.8)
				{
					if (display.guessMode == false)
					{
						display.guessMode = true;
						display.numDrawn = -1;
						display.nextWord();
					}
					loadingText.setText("hide");
				}
			}
			
			if (showTransition == true)
			{
				loadingText.size = 24;
				loadingText.offset = -150;
				loadingText.setText("Someone identified your " + gotName + "!");
				if (showWait > 0.8)
				{
					loadingText.setText("hide");
				}
			}


			
			/*if (finishStartup == true && startup == true)
			{
				timer.time = 0.0;
				loadWait += 0.01;
				if (loadWait > 1.0)
				{
					finishStartup = false;
					startup = false;
				}
			}*/
			
			super.render();
			Draw.rectPlus(0, 0, FP.width, FP.height, FP.getColorRGB(255, 255, 255), startupAlpha);
			loadingText.render();
			loader.render();
			
			
			text.color = FP.getColorRGB(200,200,200);
			text.size = 16;
			text.font = "myriad";
			text.align = "center";
			
			if(User.score == 0)
				text.text = "No one has correctly identified any of your doodles!";
			else if(User.score == 1)
				text.text = User.score + " person has correctly identified your doodles!";	
			else
				text.text = User.score + " people have correctly identified your doodles!";		
			
			text.centerOrigin();
			text.x = FP.width / 2;
			text.y = (FP.height / 2) + 190;
			text.alpha = startupAlpha;
			
			text.render(FP.buffer, new Point(), FP.camera);
			
			
			text2.color = FP.getColorRGB(200,200,200);
			text2.size = 16;
			text2.font = "myriad";
			text2.align = "center";
			
			if(User.success == 0)
				text2.text = "You haven't correctly guessed any doodles!";
			else if(User.success == 1)
				text2.text = "You have correctly identified " + User.success + " doodle!";	
			else
				text2.text = "You have correctly identified " + User.success + " doodles!";			
			
			text2.centerOrigin();
			text2.x = FP.width / 2;
			text2.y = (FP.height / 2) + 210;
			text2.alpha = startupAlpha;
			
			text2.render(FP.buffer, new Point(), FP.camera);
			
			
			
			if (graph != null && showTransition)
			{
				graph.centerOrigin();
				graph.x = FP.width / 2;
				graph.y = FP.height / 2;
				graph.alpha = startupAlpha;
				graph.render(FP.buffer, new Point(), FP.camera);
			}
			
			
		}
		
	}

}