package  
{
	import flash.display.BlendMode;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.geom.Rectangle;
	import net.flashpunk.Entity;
	import flash.display.BitmapData;
	import flash.geom.Point;
	import net.flashpunk.Graphic;
	import net.flashpunk.graphics.Image;
	import net.flashpunk.graphics.Text;
	import net.flashpunk.World;
	import net.flashpunk.FP;
	import net.flashpunk.utils.Input;
	import net.flashpunk.utils.Draw;
	import net.flashpunk.utils.Key;
	
	import flash.net.URLRequestMethod;
	import flash.net.URLVariables;
	import flash.net.URLLoader;
	import flash.net.URLLoaderDataFormat;
	import flash.net.URLRequest;
	
	public class LetterDisplay extends Entity 
	{
		[Embed(source = "assets\\letterStrip.png")] private var sprLetters:Class;
		private var letters:Image = new Image(sprLetters);
		public var buffer:BitmapData = new BitmapData(256, 22, false, 0xFFFFFFFF);
		
		public static var numLetters = 12;
		public static var letterHeight:Number = 24;
		public static var currentID = -1;
		public static var currentUser:String = "";
		
		
		public var library:Array = new Array();
		public var usedWords:Array = new Array();
		public var currentWord:int = -1;
		
		public var word:String = "";
		public var typedWord:String = "";
		
		public var qq:Number = 0.0;
		public var positions:Array = new Array();
		public var numDrawn:int = -1;
		
		public var flashRight:Number = 0.0;
		public var flashWrong:Number = 0.0;
		
		public var guessMode:Boolean = true;
		public var inputLock:Boolean = true;
		var gotRight:Boolean = false;
		var gotWrong:Boolean = false;
		var wait:Boolean = false;
		
		[Embed(source = 'assets/MYRIADAS.TTF', embedAsCFF = "false", fontFamily = 'myriad')] private const font:Class;
		public var text:Text = new Text( "", 0, 0 );

		public function LetterDisplay() 
		{
			for (var i:int = 0; i < numLetters; i++)
			{
				positions.push(0.0);
			}
			
			library.push("PEANUT");
			library.push("FLOWER");
			library.push("LAPTOP");
			library.push("TV");
			library.push("MURDER");
			library.push("SANDWICH");
			library.push("PENIS");
			library.push("FIRE");
			library.push("TANK");
			library.push("TEAPOT");
			library.push("GUITAR");
			library.push("BRIDGE");
			library.push("BLACK");
			library.push("VAN");
			library.push("SKATEBOARDER");
			library.push("LOLLIPOP");
			library.push("CAT");
			library.push("BONG");
			library.push("FRIDGE");
			library.push("SERIOUS");
			library.push("HAPPY");
			library.push("SAD");
			library.push("ANGRY");
			library.push("CONFUSED");
			library.push("LARCH");
			library.push("BURGER");
			library.push("SAUSAGE");
			library.push("CHIPS");
			library.push("ANKLE");
			library.push("KEYS");
			library.push("CHICKEN");
			library.push("MCNUGGET");
			library.push("CONTROLLER");
			library.push("ARCADE");
			library.push("VIBRAPHONE");
			library.push("CELLO");
			library.push("HARPSICHORD");
			library.push("DNA");
			library.push("POVERTY");
			library.push("MICROWAVE");
			library.push("FOOTBALL");
			library.push("SOCCERBALL");
			library.push("SCREWDRIVER");
			library.push("APPLE");
			library.push("ORANGE");
			library.push("TRAIN");
			library.push("BUS");
			library.push("FORK");
			library.push("SPORK");
			library.push("SHRUBBERY");
			library.push("CASTLE");
			library.push("HOUSE");
			library.push("BEER");
			library.push("CHAIR");
			library.push("SOCK");
			library.push("SOCKS");
			library.push("CHEESE");
			library.push("SPOON");
			library.push("TOILET");
			library.push("OUTHOUSE");
			library.push("SPONGE");
			library.push("SCISSORS");
			library.push("SPHINX");
			library.push("POPEYE");
			library.push("AIRPLANE");
			library.push("USB");
			library.push("BUSINESSMAN");
			library.push("HEADPHONES");
			library.push("BED");
			library.push("SCIENCE");
			library.push("SATURN");
			library.push("COMPUTER");
			library.push("SOCKS");
			library.push("INSIDE");
			library.push("FISH");
			library.push("WOODSTOCK");
			library.push("GHETTO");
			library.push("BEACH");
			library.push("DESERT");
			library.push("FOREST");
			library.push("DODECAHEDRON");
			library.push("WHEELCHAIR");
			library.push("NACHOS");
			library.push("TACO");
			library.push("SUBMARINE");
			library.push("HIPSTER");
			library.push("GANGSTER");
			library.push("BRO");
			library.push("DOCTOR");
			library.push("RACECAR");
			library.push("ELEPHANT");
			library.push("GIRAFFE");
			library.push("HAMSTER");
			library.push("CUBE");
			library.push("GOBLET");
			library.push("LAMP");
			library.push("COW");
			library.push("SLAUGHTER");
			library.push("COMIC");
			library.push("SHOES");
			library.push("XBOX");
			library.push("PLAYSTATION");
			library.push("UKELELE");
			library.push("CYBORG");
			library.push("TERMINATOR");
			library.push("ROBOCOP");
			library.push("HEART");
			library.push("FART");
			library.push("SLAP");
			library.push("COCKTAIL");
			library.push("TURBAN");
			library.push("TEACUP");
			library.push("TOOTHBRUSH");
			library.push("HAYSTACK");
			library.push("SKULL");
			library.push("SKELETON");
			library.push("NUKE");
			library.push("SCRIBBLES");
			library.push("BORDER");
			library.push("TUNNEL");
			library.push("CARROT");
			library.push("COFFEE");
			library.push("SPAM");
			library.push("DONUT");
			library.push("TRIANGLE");
			library.push("CIRCLE");
			library.push("DOT");
			library.push("MONALISA");
			library.push("TECHNODROME");
			library.push("TARDIS");
			library.push("DALEK");
			library.push("DEATH");
			library.push("LIFE");
			library.push("POOL");
			library.push("LINE");
			library.push("STINKY");
			library.push("EARTHWORM");
			library.push("CLOSET");
			library.push("BAR");
			library.push("CLUB");
			library.push("SUPERMAN");
			library.push("BATMAN");
			library.push("SWORD");
			library.push("BOREDOM");
			library.push("NAP");
			library.push("STEAM");
			library.push("WEETABIX");
			library.push("HIPPIE");
			library.push("VAMPIRE");
			library.push("COBRA");
			library.push("WEED");
			library.push("PIKACHU");
			library.push("BOOMERANG");
			library.push("REGICIDE");
			library.push("SNIPER");
			library.push("MUSHROOM");
			library.push("GANGSTER");
			library.push("BLOPS");
			library.push("BELLY");
			library.push("PARACHUTE");
			library.push("SKYDIVE");
			library.push("THUNDER");
			library.push("CHALK");
			library.push("FISHTANK");
			library.push("BEAVER");
			library.push("MINECRAFT");
			library.push("OBAMA");
			library.push("JAKE");
			library.push("FINN");
			library.push("BUBBLEGUM");
			library.push("KEYTAR");
			library.push("LEGO");
			library.push("HITLER");
			library.push("LOL");
			library.push("BIGBIRD");
			library.push("ELMO");
			library.push("SPACESHIP");
			library.push("BOXER");
			library.push("BILLYMAYS");
			library.push("TEEPEE");
			library.push("PLUNGER");
			library.push("TELEPHONE");
			library.push("JESUS");
			library.push("MOHAMMED");
			library.push("STALIN");
			library.push("RAPTOR");
			library.push("TREX");
			library.push("PAPERCLIP");
			library.push("STAPLER");
			library.push("TOASTER");
			library.push("BREAD");
			library.push("CRAYON");
			library.push("EARTH");
			library.push("DINOSAUR");
			library.push("KNIFE");
			library.push("DRUMSET");
			library.push("CRATE");
			library.push("CRAPPYDOODLE");
			library.push("KNIGHT");
			library.push("STICKMAN");
			library.push("STICKDOG");
			library.push("CHECKERBOARD");
			library.push("RHOMBUS");
			library.push("PUSHPIN");
			library.push("LLAMA");
			library.push("VASE");
			library.push("ETCHASKETCH");
			library.push("RUBIXCUBE");
			library.push("POO");
			library.push("BUTT");
			library.push("CROWN");		
			library.push("SODA");
			library.push("PYLON");
			library.push("OUYA");
			library.push("LIGHTBULB");
			library.push("SALESMAN");
			library.push("CANDY");
			library.push("KEY");
			library.push("RAYGUN");
			library.push("CAPTAIN");
			library.push("SEESAW");
			library.push("SWING");
			library.push("ROBOT");
			library.push("DRUGS");
			library.push("JERK");
			library.push("LOSER");
			library.push("YOU");
			library.push("YOUTUBE");
			library.push("WIZARD");
			library.push("NERD");			
			library.push("BARREL");		
			library.push("GAMEBOY");
			library.push("SKYSCRAPER");	
			library.push("EGG");	
			library.push("BACON");	
			library.push("SUN");	
			library.push("SPIRAL");
			library.push("COUCH");
			library.push("HOSPITAL");
			library.push("CONCH");
			library.push("MAILMAN");
			library.push("PACMAN");
			library.push("MARIO");
			library.push("WATERMELON");
			library.push("TAPEMEASURE");
			library.push("PUMPKIN");
			library.push("PIZZA");
			library.push("CLOUD");
			library.push("MOUNTAIN");
			library.push("BOAT");
			library.push("BOMB");			
			library.push("GNOME");
			library.push("PALMTREE");
			library.push("PRETZEL");
			library.push("IGLOO");
			library.push("CAMPFIRE");
			library.push("STARFISH");
			library.push("UNICYCLE");
			library.push("WINEGLASS");
			library.push("EYE");
			library.push("WINDMILL");
			library.push("INFINITY");
			library.push("HAT");
			library.push("NIGEL");
			library.push("RECORD");
			library.push("DUCK");
			library.push("RUBBERDUCK");
			library.push("FURBY");
			library.push("PEPSI");
			library.push("THEGAME");
			library.push("BATTERY");
			library.push("LIGHTER");
			library.push("AXE");
			library.push("HAMMER");
			library.push("SNOWMAN");
			library.push("HAND");
			library.push("SPACEMAN");
			library.push("RAINBOW");
			library.push("BALOON");
			library.push("WRENCH");
			library.push("TSHIRT");
			library.push("FEDORA");
			library.push("TOPHAT");
			library.push("LINCOLN");
			library.push("FRYINGPAN");
			library.push("MENSROOM");
			library.push("RECLINER");
			library.push("PILLOW");
			library.push("WINDOW");
			library.push("WINDOWS");
			library.push("REVOLVER");
			library.push("TRUMPET");
			library.push("COMB");
			library.push("SAW");
			library.push("LOCK");
			library.push("CLIPBOARD");
			library.push("GEAR");
			library.push("GEARS");
			library.push("PIGGYBANK");
			library.push("MEGAPHONE");
			library.push("BUTTON");
			library.push("ZIPPER");
			library.push("SAFETYPIN");
			library.push("TOILETPAPER");
			library.push("KLEENEX");
			library.push("BANDAID");
			library.push("PILL");
			library.push("FOUNTAIN");
			library.push("WATERFALL");
			library.push("PAWN");
			library.push("CREEPER");
			library.push("ZEPPELIN");
			
			text.color = FP.getColorRGB(180,180,180);
			text.size = 16;
			text.font = "myriad";
			text.align = "center";
			text.text = "(<-)Cheater!                  I don't know!(->)";		
			
			text.centerOrigin();
			text.x = FP.width / 2;
			text.y = 428;
		}
		
		public static function addGuess() : void 
		{
			var variables:URLVariables = new URLVariables("sendRequest=crappyDoodles");
			variables.id = currentUser;
			variables.correct = currentID;
			
			var varSend:URLRequest = new URLRequest("http://www.wonthelp.info/crappydoodle/addGuess.php");
			varSend.method = URLRequestMethod.POST;
			varSend.data = variables;
			var varLoader:URLLoader = new URLLoader;
			varLoader.dataFormat = URLLoaderDataFormat.VARIABLES;
			varLoader.addEventListener(Event.COMPLETE, onUpload);
			varLoader.load(varSend);	
		}
		
		private static function onUpload(e:Event) : void
		{
			var qq;
		}
		
		public function finishWord() : void
		{
			if (guessMode == false)
			{
				if (word != "")
					User.drawn.push(word);
			}
			else
			{
				if (currentID != -1)
				{
					if (User.guesses == "")
						User.guesses += currentID;
					else
						User.guesses += "," + currentID;
						
					User.upload();
				}
			}
		}
		
		public function nextWord() : void
		{
			if (guessMode == false)
			{
				var remainingWords:Array = new Array();
				for (var i:int = 0; i < library.length; i++)
				{
					var item:String = library[i] as String;
					if (User.drawn.indexOf(item) == -1)
					{
						remainingWords.push(item);
					}
				}
				
				//Restart from beginning if out of words
				if (remainingWords.length == 0)
				{
					User.drawn = new Array();
					nextWord();
					return;
				}
				
				var w:int = Math.round(FP.random * (remainingWords.length - 1));
				
				currentWord = w;
				word = remainingWords[w] as String;
				numDrawn += 1;
				typedWord = "";
				Loader.loading = false;
				wait = false;
			}
			else
			{
				Canvas.canvas.download();
				numDrawn += 1;
				wait = false;
			}
		}
		
		public override function update():void
		{
			text.alpha = Fun.lerp(text.alpha, DoodleWorld.guessMode ? 1.0 : 0.0, 0.05, 0.05);
			
			flashRight = Fun.lerp(flashRight, 0.0, 0.05, 0.05);
			flashWrong = Fun.lerp(flashWrong, 0.0, 0.05, 0.05);
			
			if (gotRight || gotWrong)
			{
				var wor:DoodleWorld = FP.world as DoodleWorld;
				wor.timer.time -= FP.elapsed / 10.0;
			}
			
			if (gotRight && flashRight < 0.01)
			{
				var wor:DoodleWorld = FP.world as DoodleWorld;
				wor.timer.time = 10.0;
				inputLock = false;
				gotRight = false;
				wait = true;
				
				addGuess();
				User.success += 1;
				
				
				//word = "";
			}
			
			if (gotWrong && flashWrong < 0.01)
			{
				var wor:DoodleWorld = FP.world as DoodleWorld;
				wor.timer.time = 10.0;
				inputLock = false;
				gotWrong = false;
				wait = true;
				//word = "";
			}		
			
			if (guessMode)
			{
				if (Input.pressed(Key.RIGHT))
				{
					gotWrong = true;
					flashWrong = 0.8;
				}
				if (Input.pressed(Key.LEFT))
				{
					gotWrong = true;
					flashWrong = 0.8;
				}
				
				
				if (word != "" && inputLock == false)
				{
					if ((Input.keyString.charCodeAt(0) >= 65 && Input.keyString.charCodeAt(0) <= 90) ||
						(Input.keyString.charCodeAt(0) >= 97 && Input.keyString.charCodeAt(0) <= 122))
					{
						typedWord += Input.keyString.charAt(0);
						typedWord = typedWord.toUpperCase();
					}
					if (Input.pressed(Key.BACKSPACE) && typedWord.length > 0)
						typedWord = typedWord.substr(0, typedWord.length - 1);
				}
					
				if (gotRight == false)
				{
					if (wait == false && word != "" && (Input.pressed(Key.ENTER) || typedWord.length >= word.length))
					{
						if (typedWord == word)
						{
							flashRight = 0.8;
							gotRight = true;
							inputLock = true;
						}
						else
						{
							flashWrong = 0.8;
							typedWord = "";
						}
					}
				}
			}
			
			Input.keyString = "";
		}
		
		public override function render() : void 
		{				
			Draw.rectPlus(x - 3, y - 3, buffer.width + 6, buffer.height + 6, FP.getColorRGB(200, 200, 200));
			
			//Draw.rectPlus(x - 3, y + 32 - 3, buffer.width + 6, buffer.height + 6, FP.getColorRGB(200, 200, 200));
			//Draw.rectPlus(x, y + 32, buffer.width, buffer.height, FP.getColorRGB(255, 255, 255));
			text.render(FP.buffer, new Point(), FP.camera);
			
			var cellWidth:Number = (buffer.width / 5) - 4;
			for (var i:int = 0; i < 5; i++)
			{
				Draw.rectPlus(1 + (x - 3) + i * (cellWidth + 6), y - 14, cellWidth, 6, i <= numDrawn ? FP.getColorRGB(200, 200, 200) : FP.getColorRGB(235, 235, 235));
			}
			
			if (guessMode == false)
			{
				buffer.fillRect(buffer.rect, 0xFFFFFF);
				var offset:Number = (buffer.width - (word.length * 20)) / 2;
				
				for (var i:int = 0; i < numLetters; i++)
				{
					var letter:int = word.charCodeAt(i) - 65;
					if (letter < 0 || letter > 26)
						letter = 26;
					
					var desiredPos:Number = -((letter) * letterHeight);
					var pos:Number = positions[i] as Number;
					
					pos = Fun.lerp(pos, desiredPos, 0.4, 0.1);
					positions[i] = pos;
					
					if(i < word.length)
						letters.render(buffer, new Point((i * 20) + offset, pos), new Point());
				}
				FP.buffer.copyPixels(buffer, buffer.rect, new Point(x, y));
			}
			else
			{
				buffer.fillRect(buffer.rect, 0xFFFFFF);
				
				var offset:Number = (buffer.width - (word.length * 20)) / 2;
				Draw.setTarget(buffer);
				for (var i:int = 0; i < numLetters; i++)
				{
					if(i < word.length)
						Draw.rectPlus((i * 20) + offset, 2, 18, 18, FP.getColorRGB(200, 200, 200));
					
					var letter:int = 26;
					if (i < typedWord.length)
						letter = typedWord.charCodeAt(i) - 65;
						
					if (letter < 0 || letter > 26)
						letter = 26;
					
					var desiredPos:Number = -((letter) * letterHeight);
					var pos:Number = positions[i] as Number;
					
					pos = Fun.lerp(pos, desiredPos, 0.3, 0.2);
					positions[i] = pos;
					
					if(i < typedWord.length)
						letters.render(buffer, new Point((i * 20) + offset, pos), new Point());
				}
				Draw.setTarget(FP.buffer);
				
				FP.buffer.copyPixels(buffer, buffer.rect, new Point(x, y));	
				
				Draw.rectPlus(x, y, buffer.width, buffer.height, FP.getColorRGB(0, 200, 0), flashRight);
				Draw.rectPlus(x, y, buffer.width, buffer.height, FP.getColorRGB(200, 0, 0), flashWrong);
			}
			
			if (word == "")
			{
				Loader.loading = true;
			}
		}
		
	}

}