package  
{
	import flash.geom.Point;
	import net.flashpunk.Entity;
	import net.flashpunk.FP;
	import net.flashpunk.utils.Input;
	import net.flashpunk.utils.Draw;
	public class Pen extends DrawingTool 
	{
		public var prevX:Number = 0.0;
		public var prevY:Number = 0.0;
		public var draw:Boolean = false;
		public var prevDraw:Boolean = false;
		public var moved:Boolean = false;
		
		public var thick:Number = 0.5;
		
		public function Pen() 
		{
			layer = -99;
		}
		
		public override function update() : void 
		{
			if (DoodleWorld.guessMode && DoodleWorld.guessTransition == false && DoodleWorld.drawTransition == false && DoodleWorld.showTransition == false)
				return;
			
			Draw.setTarget(Canvas.canvas.buffer);
			
			prevX = x;
			prevY = y;
			x = Input.mouseX;
			y = Input.mouseY;
			
			prevDraw = draw;
			if (draw == false && Input.mouseDown)
			{
				draw = true;
				moved = false;
				
				prevX = x;
				prevY = y;
			}
			if (Input.mouseDown == false)
				draw = false;
		
			if (draw && (x - prevX != 0 || y - prevY != 0))
			{
				moved = true;
				
				var dif:Point = (new Point(x, y)).subtract(new Point(prevX, prevY));
				
				
				var norm:Point = new Point(dif.x, dif.y);
				norm.normalize(1);			
				
				var newThick:Number = dif.length / 4.0;	
				if (newThick < 0.5)
					newThick = 0.5;
				if (newThick > 4.0)
					newThick = 4.0;
					
				var curThick:Number = thick;
				for (var i:int = 0; i < dif.length; i++)
				{
					var pos:Point = new Point(prevX + (norm.x * i), prevY + (norm.y * i));
					Draw.circlePlus(pos.x - Canvas.canvas.x, pos.y - Canvas.canvas.y, thick, 0x000000, 1);
					thick += ((newThick - curThick) / dif.length) * 0.2;			
				}
				//Draw.linePlus(x - Canvas.canvas.x, y - Canvas.canvas.y, prevX - Canvas.canvas.x, prevY - Canvas.canvas.y, 0x000000, 1, dif.length / 10);
			}
			
			if (draw == false && prevDraw == true && moved == false)
			{
				Draw.circlePlus(x - Canvas.canvas.x, y - Canvas.canvas.y, thick, 0x000000, 1);
			}
			Draw.setTarget(FP.buffer);
		}
		
		public override function render() : void 
		{
			if (DoodleWorld.guessMode)
				return;
			
			Draw.circlePlus(x, y, 2, 0x000000, 1, true);
		}
		
	}

}