package  
{
	import flash.display.BlendMode;
	import flash.display.Sprite;
	import flash.geom.Rectangle;
	import net.flashpunk.Entity;
	import flash.display.BitmapData;
	import flash.geom.Point;
	import net.flashpunk.Graphic;
	import net.flashpunk.graphics.Image;
	import net.flashpunk.World;
	import net.flashpunk.FP;
	import net.flashpunk.utils.Input;
	import net.flashpunk.utils.Draw;
	public class PieTimer extends Entity 
	{
		var radius:Number = 26;
		var halfCircle:Image;
		var clearSprite:Image;
		
		var buffer:BitmapData;
		var overlayBuffer:BitmapData;
		
		var time:Number = 0.0;
		
		public function PieTimer(xpos:int, ypos:int) 
		{
			x = xpos;
			y = ypos;
			
			
			var dat:BitmapData = new BitmapData( radius, radius * 2 );
			dat.fillRect(dat.rect, FP.getColorRGB(255,255,255) | 0xFF000000);
			
			Draw.setTarget(dat, FP.camera, BlendMode.NORMAL);
			Draw.circlePlus(radius, radius, radius, FP.getColorRGB(225,225,225), 1);
			
			halfCircle = new Image(dat);
			halfCircle.originX = radius;
			halfCircle.originY = radius;
			
			var dat2:BitmapData = new BitmapData( radius + 5, (radius + 5) * 2 );
			dat2.fillRect(dat2.rect, FP.getColorRGB(255, 255, 255) | 0xFF000000);
			clearSprite = new Image(dat2);
			clearSprite.originX = 0;
			clearSprite.originY = radius + 5;
			
			buffer = new BitmapData(radius * 2, radius * 2, false, 0xFFFFFFFF);
			overlayBuffer = new BitmapData(radius * 2, radius * 2, true, 0x00000000);
		
			//Generate overlay circle
			Draw.setTarget(overlayBuffer, FP.camera, BlendMode.NORMAL);
			Draw.rectPlus(0, 0, overlayBuffer.width, overlayBuffer.height, FP.getColorRGB(255, 255, 255), 1, true);
			//Draw.setTarget(overlayBuffer, FP.camera, BlendMode.ERASE);
			Draw.circlePlus(overlayBuffer.width / 2, overlayBuffer.height / 2, radius, FP.getColorRGB(225, 225, 225), 1, true);
			Draw.setTarget(FP.buffer);
		}
		
		public override function render() : void
		{	
			if(DoodleWorld.currentWord != "")
				time += FP.elapsed / 10.0;
			else
				time = 0;
				
				
			if (time > 1.0)
				time = 1.0;
			
			Draw.setTarget(buffer, FP.camera, BlendMode.NORMAL);
			Draw.rectPlus(0, 0, overlayBuffer.width, overlayBuffer.height, FP.getColorRGB(225, 225, 225), 1, true);
			Draw.setTarget(FP.buffer);
			
			
			
			
			
			
			//if (time >= 0.5)
			//	clearSprite.render(buffer, new Point(radius, radius), FP.camera);
			
			
			
			buffer.copyPixels(overlayBuffer, overlayBuffer.rect, new Point(0, 0));
			
			if (time < 0.5)
			{
				clearSprite.angle = ((0.5 - time) / 0.5) * 180; 
				clearSprite.render(buffer, new Point(radius, radius), FP.camera);
				
				halfCircle.render(buffer, new Point(radius, radius), FP.camera);
			}
			else
			{
				clearSprite.angle = 0; 
				clearSprite.render(buffer, new Point(radius, radius), FP.camera);
				
				clearSprite.angle = (((time - 0.5)) / 0.5) * -180; 
				clearSprite.render(buffer, new Point(radius, radius), FP.camera);
			}
				
			/*if (time >= 0.5)
			{
				sprite.angle = 180 + (((time - 0.5) / 0.5) * -180); 
			}
			else
				sprite.angle = 180;*/
			
			//sprite.angle = 180;*/
			//sprite.render(buffer, new Point(radius, radius), FP.camera);
			
			
			
			//Draw.circlePlus(x, y, radius, 0xFFFFFF);
			
			//sprite.render(FP.buffer, new Point(x, y), FP.camera);
			
			
			
			
			
			//var dat:BitmapData = new BitmapData( radius * 2, radius );
			//dat.fillRect(dat.rect, FP.getColorRGB(225, 225, 225) | 0xFF000000);
			
			FP.buffer.copyPixels(buffer, buffer.rect, new Point(x - radius, y - radius));
			
			Draw.circlePlus(x, y, radius, FP.getColorRGB(200, 200, 200), 1, false, 3);
			
			
		}
		
	}

}